#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <errno.h>
#include <getopt.h>
#include <string.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <signal.h>
#include <unistd.h>
#include <linux/serial.h>

#define DEVICE_TTY "/dev/ttyS2"

static int rs485_delay = 2000;
void enable_rs485(int fd)
{
	int ret = -1;
    struct serial_rs485 rs485conf;

    memset(&rs485conf,0,sizeof(rs485conf));

	fprintf(stderr,"rs485 ioctl\n");
	/* Set the port in 485 mode */
	if (ioctl(fd, TIOCGRS485, &rs485conf) < 0) {
		printf("Error getting rs485 mode.\n");
	}
	else {
		rs485conf.flags = SER_RS485_ENABLED | SER_RS485_RTS_ON_SEND;
		rs485conf.delay_rts_before_send = 0;
		rs485conf.delay_rts_after_send = rs485_delay;
        rs485conf.padding[0] = 68;   //用来控制slaver收发的gpio index

		ret = ioctl(fd, TIOCSRS485, &rs485conf);
		if (ret) {
			printf("Unable to configure port in 485 mode, status (%i)\n", ret);
		}
	}
}


int main(int argc, char **argv)
{
        int fd;
		char buf[512] = {0};
        fd = open(DEVICE_TTY, O_RDWR);
        if (fd <= 0){
                printf("Can't Open Serial Port!\n");
                return -1;
        }
        enable_rs485(fd);
        do{
            read(fd,buf,sizeof(buf)-1);
			printf("read:%s\n",buf);
			memset(buf,0,sizeof(buf));
        }while(0)
        printf("enable rs485\n");
        close(fd);
        return 0;
}


